#include <LiquidCrystal.h>
const int LCD_RS = 13;
const int LCD_EN = 12;
const int LCD_D4 = 11;
const int LCD_D5 = 10;
const int LCD_D6 = 9;
const int LCD_D7 = 8;
LiquidCrystal ekran(LCD_RS, LCD_EN, LCD_D4, LCD_D5, LCD_D6, LCD_D7);

const int BTN_R = 7;
const int BTN_G = 4;
const int BTN_B = 2;

const int LED_R = 6;
const int LED_G = 5;
const int LED_B = 3;

const int AN_Value = A0;
const int AN_Min = A1;
const int AN_Max = A2;

char txt[5];
int valueR = 0, minR = 0, maxR = 100;
int valueG = 0, minG = 0, maxG = 100;
int valueB = 0, minB = 0, maxB = 100;

const int secimYok = 0;
const int secimR = 1;
const int secimG = 2;
const int secimB = 3;
int secim = 0;

int timeOut = 0;

void setup() {
  // put your setup code here, to run once:
  ekran.begin(20, 4);
  ekran.clear();

  pinMode(BTN_R, INPUT_PULLUP);
  pinMode(BTN_G, INPUT_PULLUP);
  pinMode(BTN_B, INPUT_PULLUP);

  pinMode(LED_R, OUTPUT);
  pinMode(LED_G, OUTPUT);
  pinMode(LED_B, OUTPUT);

}

void loop() {
  // put your main code here, to run repeatedly:
  readDigitalInputs();
  readAnalogInputs();
  updateOutputs();
  updateScreen();
}
void readAnalogInputs() {
  if (secim == secimR) {
    maxR = map(analogRead(AN_Max), 0, 1023, 0, 100);
    minR = map(analogRead(AN_Min), 0, 1023, 0, 100);
    if (maxR < minR)maxR = minR;
    valueR = map(analogRead(AN_Value), 0, 1023, minR, maxR);
  }
  if (secim == secimG) {
    maxG = map(analogRead(AN_Max), 0, 1023, 0, 100);
    minG = map(analogRead(AN_Min), 0, 1023, 0, 100);
    if (maxG < minG)maxG = minG;
    valueG = map(analogRead(AN_Value), 0, 1023, minG, maxG);
  }
  if (secim == secimB) {
    maxB = map(analogRead(AN_Max), 0, 1023, 0, 100);
    minB = map(analogRead(AN_Min), 0, 1023, 0, 100);
    if (maxB < minB)maxB = minB;
    valueB = map(analogRead(AN_Value), 0, 1023, minB, maxB);
  }
}
void readDigitalInputs() {
  if (digitalRead(BTN_R) == LOW) {
    if (secim != secimR)secim = secimR;
    else secim = secimYok;
    timeOut = millis();
    while (digitalRead(BTN_R) == LOW)if (millis() - timeOut > 1000)break;
  }
  if (digitalRead(BTN_G) == LOW) {
    if (secim != secimG)secim = secimG;
    else secim = secimYok;
    timeOut = millis();
    while (digitalRead(BTN_G) == LOW)if (millis() - timeOut > 1000)break;
  }
  if (digitalRead(BTN_B) == LOW) {
    if (secim != secimB)secim = secimB;
    else secim = secimYok;
    timeOut = millis();
    while (digitalRead(BTN_B) == LOW)if (millis() - timeOut > 1000)break;
  }
}
void updateOutputs(){
  analogWrite(LED_R,map(valueR,0,100,0,255));
  analogWrite(LED_G,map(valueG,0,100,0,255));
  analogWrite(LED_B,map(valueB,0,100,0,255));
}
void updateScreen() {
  ekran.home();
  ekran.print("VALUE");
  ekran.setCursor(8, 0);
  ekran.print("MIN");
  ekran.setCursor(14, 0);
  ekran.print("MAX");

  ekran.setCursor(1, 1);
  ekran.print("R:%");
  sprintf(txt, "%3d", valueR);
  ekran.print(txt);
  ekran.setCursor(8, 1);
  ekran.print("L:%");
  sprintf(txt, "%2d", minR);
  ekran.print(txt);
  ekran.setCursor(14, 1);
  ekran.print("H:%");
  sprintf(txt, "%3d", maxR);
  ekran.print(txt);

  ekran.setCursor(1, 2);
  ekran.print("G:%");
  sprintf(txt, "%3d", valueG);
  ekran.print(txt);
  ekran.setCursor(8, 2);
  ekran.print("L:%");
  sprintf(txt, "%2d", minG);
  ekran.print(txt);
  ekran.setCursor(14, 2);
  ekran.print("H:%");
  sprintf(txt, "%3d", maxG);
  ekran.print(txt);

  ekran.setCursor(1, 3);
  ekran.print("B:%");
  sprintf(txt, "%3d", valueB);
  ekran.print(txt);
  ekran.setCursor(8, 3);
  ekran.print("L:%");
  sprintf(txt, "%2d", minB);
  ekran.print(txt);
  ekran.setCursor(14, 3);
  ekran.print("H:%");
  sprintf(txt, "%3d", maxB);
  ekran.print(txt);

  switch (secim) {
    case secimYok:
      ekran.setCursor(0, 1);
      ekran.print(" ");
      ekran.setCursor(0, 2);
      ekran.print(" ");
      ekran.setCursor(0, 3);
      ekran.print(" ");
      break;
    case secimR:
      ekran.setCursor(0, 1);
      ekran.print(">");
      ekran.setCursor(0, 2);
      ekran.print(" ");
      ekran.setCursor(0, 3);
      ekran.print(" ");
      break;
    case secimG:
      ekran.setCursor(0, 1);
      ekran.print(" ");
      ekran.setCursor(0, 2);
      ekran.print(">");
      ekran.setCursor(0, 3);
      ekran.print(" ");
      break;
    case secimB:
      ekran.setCursor(0, 1);
      ekran.print(" ");
      ekran.setCursor(0, 2);
      ekran.print(" ");
      ekran.setCursor(0, 3);
      ekran.print(">");
      break;
  }
}

